/*
 *   Javascript handler for the admin panel
 */

var fortguard = (function ($) {
  document.addEventListener("DOMContentLoaded", function () {
    var contentSpamToggle = document.getElementById("toggle-content-spam");
    var contentSpamContainer = document.getElementById(
      "content-spam-container"
    );

    function toggleVisibility() {
      contentSpamContainer.style.display = contentSpamToggle.checked
        ? "block"
        : "none";
    }

    contentSpamToggle.addEventListener("change", toggleVisibility);
    toggleVisibility();
  });

  document.addEventListener("DOMContentLoaded", function () {
    var locationSpamToggle = document.getElementById("toggle-location-spam");
    var locationSpamContainer = document.getElementById(
      "location-spam-container"
    );

    function toggleVisibility() {
      locationSpamContainer.style.display = locationSpamToggle.checked
        ? "block"
        : "none";
    }

    locationSpamToggle.addEventListener("change", toggleVisibility);
    toggleVisibility();
  });

  document.addEventListener("DOMContentLoaded", function () {
    var languageSpamToggle = document.getElementById("toggle-language-spam");
    var languageSpamContainer = document.getElementById(
      "language-spam-container"
    );

    function toggleVisibility() {
      languageSpamContainer.style.display = languageSpamToggle.checked
        ? "block"
        : "none";
    }

    languageSpamToggle.addEventListener("change", toggleVisibility);
    toggleVisibility();
  });

  document.addEventListener("DOMContentLoaded", function () {
    var sentimentSpamToggle = document.getElementById("toggle-sentiment-spam");
    var sentimentSpamContainer = document.getElementById(
      "sentiment-spam-container"
    );

    function toggleVisibility() {
      sentimentSpamContainer.style.display = sentimentSpamToggle.checked
        ? "block"
        : "none";
    }

    sentimentSpamToggle.addEventListener("change", toggleVisibility);
    toggleVisibility();
  });
  var countryCodeMap = {
    Afghanistan: "AF",
    Albania: "AL",
    Algeria: "DZ",
    "American Samoa": "AS",
    Andorra: "AD",
    Angola: "AO",
    Anguilla: "AI",
    Antarctica: "AQ",
    "Antigua and Barbuda": "AG",
    Argentina: "AR",
    Armenia: "AM",
    Aruba: "AW",
    Australia: "AU",
    Austria: "AT",
    Azerbaijan: "AZ",
    Bahamas: "BS",
    Bahrain: "BH",
    Bangladesh: "BD",
    Barbados: "BB",
    Belarus: "BY",
    Belgium: "BE",
    Belize: "BZ",
    Benin: "BJ",
    Bermuda: "BM",
    Bhutan: "BT",
    "Bolivia, Plurinational State of": "BO",
    "Bonaire, Sint Eustatius and Saba": "BQ",
    "Bosnia and Herzegovina": "BA",
    Botswana: "BW",
    "Bouvet Island": "BV",
    Brazil: "BR",
    "British Indian Ocean Territory": "IO",
    "Brunei Darussalam": "BN",
    Bulgaria: "BG",
    "Burkina Faso": "BF",
    Burundi: "BI",
    Cambodia: "KH",
    Cameroon: "CM",
    Canada: "CA",
    "Cape Verde": "CV",
    "Cayman Islands": "KY",
    "Central African Republic": "CF",
    Chad: "TD",
    Chile: "CL",
    China: "CN",
    "Christmas Island": "CX",
    "Cocos (Keeling) Islands": "CC",
    Colombia: "CO",
    Comoros: "KM",
    Congo: "CG",
    "Congo, the Democratic Republic of the": "CD",
    "Cook Islands": "CK",
    "Costa Rica": "CR",
    Croatia: "HR",
    Cuba: "CU",
    Curaçao: "CW",
    Cyprus: "CY",
    "Czech Republic": "CZ",
    "Côte d'Ivoire": "CI",
    Denmark: "DK",
    Djibouti: "DJ",
    Dominica: "DM",
    "Dominican Republic": "DO",
    Ecuador: "EC",
    Egypt: "EG",
    "El Salvador": "SV",
    "Equatorial Guinea": "GQ",
    Eritrea: "ER",
    Estonia: "EE",
    Ethiopia: "ET",
    "Falkland Islands (Malvinas)": "FK",
    "Faroe Islands": "FO",
    Fiji: "FJ",
    Finland: "FI",
    France: "FR",
    "French Guiana": "GF",
    "French Polynesia": "PF",
    "French Southern Territories": "TF",
    Gabon: "GA",
    Gambia: "GM",
    Georgia: "GE",
    Germany: "DE",
    Ghana: "GH",
    Gibraltar: "GI",
    Greece: "GR",
    Greenland: "GL",
    Grenada: "GD",
    Guadeloupe: "GP",
    Guam: "GU",
    Guatemala: "GT",
    Guernsey: "GG",
    Guinea: "GN",
    "Guinea-Bissau": "GW",
    Guyana: "GY",
    Haiti: "HT",
    "Heard Island and McDonald Islands": "HM",
    "Holy See (Vatican City State)": "VA",
    Honduras: "HN",
    "Hong Kong": "HK",
    Hungary: "HU",
    Iceland: "IS",
    India: "IN",
    Indonesia: "ID",
    "Iran, Islamic Republic of": "IR",
    Iraq: "IQ",
    Ireland: "IE",
    "Isle of Man": "IM",
    Israel: "IL",
    Italy: "IT",
    Jamaica: "JM",
    Japan: "JP",
    Jersey: "JE",
    Jordan: "JO",
    Kazakhstan: "KZ",
    Kenya: "KE",
    Kiribati: "KI",
    "Korea, Democratic People's Republic of": "KP",
    "Korea, Republic of": "KR",
    Kuwait: "KW",
    Kyrgyzstan: "KG",
    "Lao People's Democratic Republic": "LA",
    Latvia: "LV",
    Lebanon: "LB",
    Lesotho: "LS",
    Liberia: "LR",
    Libya: "LY",
    Liechtenstein: "LI",
    Lithuania: "LT",
    Luxembourg: "LU",
    Macao: "MO",
    "Macedonia, the Former Yugoslav Republic of": "MK",
    Madagascar: "MG",
    Malawi: "MW",
    Malaysia: "MY",
    Maldives: "MV",
    Mali: "ML",
    Malta: "MT",
    "Marshall Islands": "MH",
    Martinique: "MQ",
    Mauritania: "MR",
    Mauritius: "MU",
    Mayotte: "YT",
    Mexico: "MX",
    "Micronesia, Federated States of": "FM",
    "Moldova, Republic of": "MD",
    Monaco: "MC",
    Mongolia: "MN",
    Montenegro: "ME",
    Montserrat: "MS",
    Morocco: "MA",
    Montserrat: "MS",
    Morocco: "MA",
    Mozambique: "MZ",
    Myanmar: "MM",
    Namibia: "NA",
    Nauru: "NR",
    Nepal: "NP",
    Netherlands: "NL",
    "New Caledonia": "NC",
    "New Zealand": "NZ",
    Nicaragua: "NI",
    Niger: "NE",
    Nigeria: "NG",
    Niue: "NU",
    "Norfolk Island": "NF",
    "Northern Mariana Islands": "MP",
    Norway: "NO",
    Oman: "OM",
    Pakistan: "PK",
    Palau: "PW",
    "Palestine, State of": "PS",
    Panama: "PA",
    "Papua New Guinea": "PG",
    Paraguay: "PY",
    Peru: "PE",
    Philippines: "PH",
    Pitcairn: "PN",
    Poland: "PL",
    Portugal: "PT",
    "Puerto Rico": "PR",
    Qatar: "QA",
    Romania: "RO",
    "Russian Federation": "RU",
    Rwanda: "RW",
    Réunion: "RE",
    "Saint Barthélemy": "BL",
    "Saint Helena, Ascension and Tristan da Cunha": "SH",
    "Saint Kitts and Nevis": "KN",
    "Saint Lucia": "LC",
    "Saint Martin (French part)": "MF",
    "Saint Pierre and Miquelon": "PM",
    "Saint Vincent and the Grenadines": "VC",
    Samoa: "WS",
    "San Marino": "SM",
    "Sao Tome and Principe": "ST",
    "Saudi Arabia": "SA",
    Senegal: "SN",
    Serbia: "RS",
    Seychelles: "SC",
    "Sierra Leone": "SL",
    Singapore: "SG",
    "Sint Maarten (Dutch part)": "SX",
    Slovakia: "SK",
    Slovenia: "SI",
    "Solomon Islands": "SB",
    Somalia: "SO",
    "South Africa": "ZA",
    "South Georgia and the South Sandwich Islands": "GS",
    "South Sudan": "SS",
    Spain: "ES",
    "Sri Lanka": "LK",
    Sudan: "SD",
    Suriname: "SR",
    "Svalbard and Jan Mayen": "SJ",
    Swaziland: "SZ",
    Sweden: "SE",
    Switzerland: "CH",
    "Syrian Arab Republic": "SY",
    "Taiwan, Province of China": "TW",
    Tajikistan: "TJ",
    "Tanzania, United Republic of": "TZ",
    Thailand: "TH",
    "Timor-Leste": "TL",
    Togo: "TG",
    Tokelau: "TK",
    Tonga: "TO",
    "Trinidad and Tobago": "TT",
    Tunisia: "TN",
    Turkey: "TR",
    Turkmenistan: "TM",
    "Turks and Caicos Islands": "TC",
    Tuvalu: "TV",
    Uganda: "UG",
    Ukraine: "UA",
    "United Arab Emirates": "AE",
    "United Kingdom": "GB",
    "United States": "US",
    "United States Minor Outlying Islands": "UM",
    Uruguay: "UY",
    Uzbekistan: "UZ",
    Vanuatu: "VU",
    "Venezuela, Bolivarian Republic of": "VE",
    "Viet Nam": "VN",
    "Virgin Islands, British": "VG",
    "Virgin Islands, U.S.": "VI",
    "Wallis and Futuna": "WF",
    "Western Sahara": "EH",
    Yemen: "YE",
    Zambia: "ZM",
    Zimbabwe: "ZW",
    "Åland Islands": "AX",
  };

  var languageCodeMap = {
    Afar: "aa",
    Abkhazian: "ab",
    Avestan: "ae",
    Afrikaans: "af",
    Akan: "ak",
    Amharic: "am",
    Aragonese: "an",
    Arabic: "ar",
    Assamese: "as",
    Avaric: "av",
    Aymara: "ay",
    Azerbaijani: "az",
    Bashkir: "ba",
    Belarusian: "be",
    Bulgarian: "bg",
    "Bihari languages": "bh",
    Bislama: "bi",
    Bambara: "bm",
    Bengali: "bn",
    Tibetan: "bo",
    Breton: "br",
    Bosnian: "bs",
    Catalan: "ca",
    Chechen: "ce",
    Chamorro: "ch",
    Corsican: "co",
    Cree: "cr",
    Czech: "cs",
    "Church Slavic": "cu",
    Chuvash: "cv",
    Welsh: "cy",
    Danish: "da",
    German: "de",
    Maldivian: "dv",
    Dzongkha: "dz",
    Ewe: "ee",
    Greek: "el",
    English: "en",
    Esperanto: "eo",
    Spanish: "es",
    Estonian: "et",
    Basque: "eu",
    Persian: "fa",
    Fulah: "ff",
    Finnish: "fi",
    Fijian: "fj",
    Faroese: "fo",
    French: "fr",
    "Western Frisian": "fy",
    Irish: "ga",
    Gaelic: "gd",
    Galician: "gl",
    Guarani: "gn",
    Gujarati: "gu",
    Manx: "gv",
    Hausa: "ha",
    Hebrew: "he",
    Hindi: "hi",
    "Hiri Motu": "ho",
    Croatian: "hr",
    Haitian: "ht",
    Hungarian: "hu",
    Armenian: "hy",
    Herero: "hz",
    Interlingua: "ia",
    Indonesian: "id",
    Interlingue: "ie",
    Igbo: "ig",
    "Sichuan Yi": "ii",
    Inupiaq: "ik",
    Ido: "io",
    Icelandic: "is",
    Italian: "it",
    Inuktitut: "iu",
    Japanese: "ja",
    Javanese: "jv",
    Georgian: "ka",
    Kongo: "kg",
    Kikuyu: "ki",
    Kuanyama: "kj",
    Kazakh: "kk",
    Kalaallisut: "kl",
    "Central Khmer": "km",
    Kannada: "kn",
    Korean: "ko",
    Kanuri: "kr",
    Kashmiri: "ks",
    Kurdish: "ku",
    Komi: "kv",
    Cornish: "kw",
    Kirghiz: "ky",
    Latin: "la",
    Luxembourgish: "lb",
    Ganda: "lg",
    Limburgan: "li",
    Lingala: "ln",
    Lao: "lo",
    Lithuanian: "lt",
    "Luba-Katanga": "lu",
    Latvian: "lv",
    Malagasy: "mg",
    Marshallese: "mh",
    Maori: "mi",
    Macedonian: "mk",
    Malayalam: "ml",
    Mongolian: "mn",
    Marathi: "mr",
    Malay: "ms",
    Maltese: "mt",
    Burmese: "my",
    Nauru: "na",
    Norwegian: "nb",
    "North Ndebele": "nd",
    Nepali: "ne",
    Ndonga: "ng",
    Dutch: "nl",
    Norwegian: "nn",
    Norwegian: "no",
    "South Ndebele": "nr",
    Navajo: "nv",
    Chichewa: "ny",
    Occitan: "oc",
    Ojibwa: "oj",
    Oromo: "om",
    Oriya: "or",
    Ossetic: "os",
    Panjabi: "pa",
    Pali: "pi",
    Polish: "pl",
    Pushto: "ps",
    Portuguese: "pt",
    Quechua: "qu",
    Romansh: "rm",
    Rundi: "rn",
    Romanian: "ro",
    Russian: "ru",
    Kinyarwanda: "rw",
    Sanskrit: "sa",
    Sardinian: "sc",
    Sindhi: "sd",
    "Northern Sami": "se",
    Sango: "sg",
    Sinhala: "si",
    Slovak: "sk",
    Slovenian: "sl",
    Samoan: "sm",
    Shona: "sn",
    Somali: "so",
    Albanian: "sq",
    Serbian: "sr",
    Swati: "ss",
    "Sotho, Southern": "st",
    Sundanese: "su",
    Swedish: "sv",
    Swahili: "sw",
    Tamil: "ta",
    Telugu: "te",
    Tajik: "tg",
    Thai: "th",
    Tigrinya: "ti",
    Turkmen: "tk",
    Tagalog: "tl",
    Tswana: "tn",
    Tonga: "to",
    Turkish: "tr",
    Tsonga: "ts",
    Tatar: "tt",
    Twi: "tw",
    Tahitian: "ty",
    Uighur: "ug",
    Ukrainian: "uk",
    Urdu: "ur",
    Uzbek: "uz",
    Venda: "ve",
    Vietnamese: "vi",
    Volapük: "vo",
    Walloon: "wa",
    Wolof: "wo",
    Xhosa: "xh",
    Yiddish: "yi",
    Yoruba: "yo",
    Zhuang: "za",
    Chinese: "zh",
    Zulu: "zu",
  };

  var sentimentsMap = {
    ADMIRATION: "ADMIRATION",
    ALTRUISM: "ALTRUISM",
    AMUSEMENT: "AMUSEMENT",
    ANXIETY: "ANXIETY",
    ANTICIPATION: "ANTICIPATION",
    CURIOUSITY: "CURIOUSITY",
    DISGUST: "DISGUST",
    ENVY: "ENVY",
    EXCITEMENT: "EXCITEMENT",
    FEAR: "FEAR",
    FLATTERY: "FLATTERY",
    GUILT: "GUILT",
    GREED: "GREED",
    HATRED: "HATRED",
    LUST: "LUST",
    MYSTERY: "MYSTERY",
    NEGATIVE: "NEGATIVE",
    NOSTALGIA: "NOSTALGIA",
    PATRIOTISM: "PATRIOTISM",
    RESENMENT: "RESENMENT",
    REGRET: "REGRET",
    SKEPTICISM: "SKEPTICISM",
    SUPIRIORITY: "SUPIRIORITY",
    URGENCY: "URGENCY",
  };

  document.addEventListener("DOMContentLoaded", function () {
    function nameToCode(map, selector) {
      var $inputField = jQuery(selector);
      var codes = $inputField.val().split(", ").filter(Boolean);
      var names = codes.map((code) => {
        for (var name in map) {
          if (map[name] === code.trim()) {
            return name;
          }
        }
        return code.trim();
      });
      $inputField.val(names.join(", "));
    }

    nameToCode(countryCodeMap, "#country_selector");
    nameToCode(languageCodeMap, "#language_selector");
  });

  $(document).ready(function () {
    $("#spam-score").on("input", function () {
      $("#spam-score-text").val(this.value);
    });
  });

  function initializeAutocomplete(selector, itemList) {
    var $selector = $(selector);
    if ($selector.length) {
      $selector.autocomplete({
        source: function (request, response) {
          var term = request.term.split(/,\s*/).pop();
          var currentValues = $selector
            .val()
            .split(",")
            .map(function (item) {
              return item.trim();
            });

          var filteredArray = $.map(itemList, function (code, name) {
            if (
              currentValues.indexOf(name) === -1 &&
              name.toUpperCase().indexOf(term.toUpperCase()) === 0
            ) {
              return { label: name, value: code };
            }
          });
          response(filteredArray);
        },
        select: function (event, ui) {
          event.preventDefault();
          var terms = this.value.split(/,\s*/);
          terms.pop();
          terms.push(ui.item.label);
          terms.push("");
          this.value = terms.join(", ").slice(0, -2);
        },
        focus: function (event, ui) {
          event.preventDefault();
        },
      });
    }
  }
  initializeAutocomplete("#country_selector", countryCodeMap);
  initializeAutocomplete("#language_selector", languageCodeMap);
  initializeAutocomplete("#sentiments-input", sentimentsMap);

  var options = fortguardAdminOptions,
    ajaxURL = options.ajaxURL,
    nonce = options.nonce;

  function saveSettings() {
    var data = {};

    var apiKey = $("#fortguard-api-key-input").val();
    if (apiKey) data.apiKey = apiKey;

    var contentSpamToggle = document.getElementById("toggle-content-spam");
    data.contentSpamToggle = contentSpamToggle.checked ? 1 : 0;

    var spamScore = $("#spam-score").val();
    if (spamScore) data.spamScore = spamScore;

    var model = $("#fortguard-model-select").val();
    if (model) data.model = model;

    var languageSpamToggle = document.getElementById("toggle-language-spam");
    data.languageSpamToggle = languageSpamToggle.checked ? 1 : 0;

    var languages = $("#language_selector").val();
    // if (languages) data.languages = languages;
    if (languages) {
      var languageNames = languages.split(",").map((name) => name.trim());
      var languageCodes = languageNames.map((name) => languageCodeMap[name]);
      data.languages = languageCodes.join(", ");
    }

    var languageExcludeInclude = $(
      'input[name="language-exclude-include"]:checked'
    ).val();
    if (languageExcludeInclude)
      data.languageExcludeInclude = languageExcludeInclude;

    var locationSpamToggle = document.getElementById("toggle-location-spam");
    data.locationSpamToggle = locationSpamToggle.checked ? 1 : 0;

    var countries = $("#country_selector").val();
    // if (countries) data.countries = countries;
    if (countries) {
      var countryNames = countries.split(",").map((name) => name.trim());
      var countryCodes = countryNames.map((name) => countryCodeMap[name]);
      data.countries = countryCodes.join(", ");
    }

    var countryExcludeInclude = $(
      'input[name="exclude-include"]:checked'
    ).val();
    if (countryExcludeInclude)
      data.countryExcludeInclude = countryExcludeInclude;

    var sentimentSpamToggle = document.getElementById("toggle-sentiment-spam");
    data.sentimentSpamToggle = sentimentSpamToggle.checked ? 1 : 0;

    var sentiments = $("#sentiments-input").val();
    data.sentiments = sentiments;

    if (Object.keys(data).length === 0) return;

    data.time = new Date().getTime();

    data.action = "save_settings";
    data.security = nonce;

    $.ajax({
      url: ajaxURL,
      method: "POST",
      data: data,
      success: function (json) {
        if (json && json.status === true) location.reload();
      },
    });
  }

  return {
    saveSettings: saveSettings,
  };
})(jQuery);
